6.0.0-git
2019-04-21

[#9475] printing messages
Summary printing messages
Queue IMP
Queue Version Git master
Type Enhancement
State Resolved
Priority 1. Low
Owners slusarz (at) horde (dot) org
Requester rsalmon (at) mbpgroup (dot) com
Created 2010-12-28 (3036 days ago)
Due
Updated 2011-01-18 (3015 days ago)
Assigned
Resolved 2011-01-18 (3015 days ago)
Milestone
Patch No

History
2011-01-18 06:47:53 Michael Slusarz Comment #20
Assigned to Michael Slusarz
State ⇒ Resolved
Reply to this comment
Is it possible to do the same when user is using traditional mode ? 
(hide sidebar and top/bottom menus) ?
I would rather not.  As mentioned before, users should not be printing 
the entire screen and it is not officially supported by us.  I added 
the print CSS to dimp to keep it somewhat backward-compatible with 
DIMP 1.x.  IMP has never had special print formatting.
2011-01-18 06:45:40 Michael Slusarz Comment #19 Reply to this comment
I've attached a message that doesn't print through the provided print link.
Fixed.
2011-01-18 06:44:39 Git Commit Comment #18 Reply to this comment
Changes have been made in Git for this ticket:

Bug #9475: ID 0 is a valid MIME ID

http://git.horde.org/horde-git/-/commit/f57f36ae85d4bda99beda581c0282a38682418ec
2011-01-10 09:01:59 rsalmon (at) mbpgroup (dot) com Comment #17
New Attachment: imp.pdf Download
Reply to this comment
I will compromise a bit for printing from the message screen - it is 
not that difficult to add a bit of CSS formatting to remove the most 
obtrusive UI-specific elements.
Thank you.
Is it possible to do the same when user is using traditional mode ? 
(hide sidebar and top/bottom menus) ?

2011-01-10 08:59:02 rsalmon (at) mbpgroup (dot) com Comment #16
New Attachment: email.eml Download
Reply to this comment
1. The page may continue to contain UI elements.  For example, for 
HTML parts with blocked images, those images will remain blocked for 
printing purposes until the user manually unblocks the images.   
Printing using the provided part links does this automatically.
I've attached a message that doesn't print through the provided print link.
2. As mentioned multiple times below, messages with inline HTML 
parts will be broken on certain browsers.  For an example, see the 
two documents I have attached.  "good-html" is printed using the 
print link for the part.  "bad-html" is the output of printing the 
entire page.
Can you post the source of the message ? I would like to try it over here.


2011-01-07 19:58:01 Michael Slusarz New Attachment: bad-html.pdf Download
 
2011-01-07 19:57:27 Michael Slusarz New Attachment: good-html.pdf Download
 
2011-01-07 19:57:12 Michael Slusarz Comment #15 Reply to this comment
I will compromise a bit for printing from the message screen - it is 
not that difficult to add a bit of CSS formatting to remove the most 
obtrusive UI-specific elements.

But understand that printing the entire page is still not going to be 
"officially" supported by us, due to the following shortcomings:

1. The page may continue to contain UI elements.  For example, for 
HTML parts with blocked images, those images will remain blocked for 
printing purposes until the user manually unblocks the images.   
Printing using the provided part links does this automatically.

Another example - you will see the Show/Hide quoted block widgets when 
printing a text part.  Again, printing using the print links will not 
show these items.

2. As mentioned multiple times below, messages with inline HTML parts 
will be broken on certain browsers.  For an example, see the two 
documents I have attached.  "good-html" is printed using the print 
link for the part.  "bad-html" is the output of printing the entire 
page.
2011-01-07 19:43:13 Git Commit Comment #14 Reply to this comment
Changes have been made in Git for this ticket:

Ticket #9475: Basic print formatting from popup message screen

http://git.horde.org/horde-git/-/commit/0b8ec8bcf692ff2e46191f3dac57b11f4f24b776
2011-01-06 09:20:17 rsalmon (at) mbpgroup (dot) com Comment #13
New Attachment: print.zip Download
Reply to this comment
To expand on this - give me an example of a message where there is 
more than one inline part that needs to be printed?  In almost every 
case, there is *ONE* part of the message that needs to be printed.   
So in almost every case, clicking print for a part is exactly what 
is intended.
I didn't have in mind multi part messages. I'll come back to you on 
this one later on.

What an end user will expect, is it to be able to print (at least) a 
simple message (only one part). And not just the body of the message 
but the header as well: info like From, To, Date.

The attached example is a single part only message (sent to the dev 
list) and will illustrate what we expect (I hope).

git-DIMP : using git DIMP, I doubled clicked on the message and use 
the print function of the browser (in my case FF).
old-DIMP: using an older version and the provided print function.
yahoo: I redirected the message and used the provided print function.
gmail: I redirected the message and used the provided print function.

To me, the better looking output is old-DIMP.pdf. It has what anyone 
can expect the header and the body of the message.

The git-DIMP output doesn't print the full message. We can see as well 
buttons like Reply, Forward, Delete...




2011-01-05 18:40:45 Michael Slusarz Comment #12 Reply to this comment
I probably misunderstand you, but you can't seriously ask end users
to open each part of a message in different windows to print them!
Yes, I am.
To expand on this - give me an example of a message where there is 
more than one inline part that needs to be printed?  In almost every 
case, there is *ONE* part of the message that needs to be printed.  So 
in almost every case, clicking print for a part is exactly what is 
intended.
2011-01-05 18:38:08 Michael Slusarz Comment #11
State ⇒ Feedback
Reply to this comment
Fwiw I agree - if printing the main screen doesn't work, there 
should be a print button to open in a view that will print properly.
But how would this work?  Printing any message with HTML content 
breaks printing the entire message (I understand this doesn't happen 
on all browsers, but that's exactly the point.  The UI has to be 
consistent across browsers - printing an email at home vs. at work 
should not produce two different outputs).

The only viable solution (outside of remove the HTML IFRAME code, 
which isn't going to happen) is to print individual parts only.  I 
believe there was discussion about this when I made the changes (last 
February) and no other solution was provided.  Thus, the links to 
print each part since it is the ONLY way to reliably print a part.
2011-01-05 18:32:38 Michael Slusarz Comment #10 Reply to this comment
I've checked gmail and yahoo mail, and they both have a print button 
(like IMP used to have) which open a message (ready to print) in a 
new window.
And these print links don't work.  Well... at least with hotmail due 
to the previously mentioned IFRAME issue.  Gmail doesn't use IFRAMEs 
and instead converts the HTML message into a series of DIVs that are 
individually formatted.  Of course it probably took a software 
engineer (or group of engineers) 6 months to develop this code, and 
they don't seem to be sharing it with others, so this is not a viable 
solution.
The only way to work around is to print EACH PART in a separate window.
I probably misunderstand you, but you can't seriously ask end users 
to open each part of a message in different windows to print them!
Yes, I am.
2010-12-30 14:41:45 Chuck Hagenbuch Comment #9
State ⇒ Accepted
Reply to this comment
Fwiw I agree - if printing the main screen doesn't work, there should 
be a print button to open in a view that will print properly.
2010-12-30 09:46:27 rsalmon (at) mbpgroup (dot) com Comment #8 Reply to this comment
This is all intentional.  Printing from the main screen does not 
work anymore - this is due to several IE/Firefox limitations that 
prevent mail messages longer than one page from printing properly.
I understand that "printing from the main screen" is closed to 
impossible to make it work. That why my original request was to re-add 
the print link feature.

I've checked gmail and yahoo mail, and they both have a print button 
(like IMP used to have) which open a message (ready to print) in a new 
window.
The only way to work around is to print EACH PART in a separate window.
I probably misunderstand you, but you can't seriously ask end users to 
open each part of a message in different windows to print them!


2010-12-29 19:46:29 Michael Slusarz Comment #7 Reply to this comment
This is all intentional.  Printing from the main screen does not work 
anymore - this is due to several IE/Firefox limitations that prevent 
mail messages longer than one page from printing properly.  The only 
way to work around is to print EACH PART in a separate window.
2010-12-29 15:34:13 Jan Schneider Comment #6 Reply to this comment
Looks like the "@media print" CSS sections got lost in IMP at some point.
2010-12-29 13:12:30 rsalmon (at) mbpgroup (dot) com Comment #5
New Attachment: imp.zip Download
Reply to this comment
attached output is printing using older IMP.
this was using old DIMP, not IMP.

I've attached output from new and old IMP.

printing using older IMP (print link) looks nice.
printing using newer IMP => output looks like anything but a message.
2010-12-29 13:05:00 rsalmon (at) mbpgroup (dot) com Comment #4
New Attachment: email-old.pdf Download
Reply to this comment
attached output is printing using older IMP.


2010-12-29 12:58:56 rsalmon (at) mbpgroup (dot) com New Attachment: email-new.pdf Download
 
2010-12-29 12:58:03 rsalmon (at) mbpgroup (dot) com Comment #3 Reply to this comment
No, anything that we did for generating a print view in IMP 4 is 
possible through CSS in IMP 5 too.
but output doesn't look as nice as before.

attached output is printing using actual git version. Buttons like 
forward, reply, view source shouldn't appear.




2010-12-28 16:45:13 Jan Schneider Comment #2
State ⇒ Rejected
Reply to this comment
No, anything that we did for generating a print view in IMP 4 is 
possible through CSS in IMP 5 too.
2010-12-28 15:21:02 rsalmon (at) mbpgroup (dot) com Comment #1
Type ⇒ Enhancement
State ⇒ New
Priority ⇒ 1. Low
Summary ⇒ printing messages
Queue ⇒ IMP
Milestone ⇒
Patch ⇒ No
Reply to this comment
There used to be a print link to print messages in IMP/DIMP.

This was really handy since we can't have a good looking output if 
printing using browser's print button.

Any chance of adding back this feature ?

Saved Queries